/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["epages.cartridges.de_epages.presentation.SearchBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.presentation.SearchBar"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.searchbar

*/


	dojo.provide("epages.cartridges.de_epages.presentation.SearchBar");
	dojo.require("epages.storage");
	dojo.require("epages.event");
	dojo.require("dojo.fx");
	dojo.require("dojox.fx");
	dojo.require("dojo.fx.easing");

	(function () {

		var replMap = {
			'<': '&lt;',
			'>': '&gt;',
			'"': '&quot;',
			"'": "\&#039;"
		},
			htmlEscape = function (value) {
				return (value + '').replace(/(<|>|"|')/g, function (all, $1) {
					return replMap[$1];
				});
			};

		epages.cartridges.de_epages.presentation.SearchBar = {

			_ELEMENT_DOJOTYPE: " dojoType='epages.widget.FormElement' ", // FormElement widget dojotype attribute
			_SEARCH_INPUT_PREFIX: "searchInput_", // prefix on which all inputs ids are extended on
			_SEARCHBAR_ANI_DURATION: 350, // default animation duration / delay

			_STORAGE_ID: "Presentation::SearchBar.Status", // namespace of this module inside of epages.Storage
			_STORAGE_EXTENDED_KEYWORD: "max", // value for the extended SearchBar stored in epages.Storage
			_STORAGE_MINIMIZED_KEYWORD: "min", // value for the minimized SearchBar stored in epages.Storage

			searchBarContainer: null, // parent node of the SearchBar
			searchBarHTMLArray: [], // collection of html snipplets which is parsed and merged on init

			searchBarId: null, // id of the SearchBar

			searchBarNodes: { // collection of important node references for easy access
				searchBarPlaceHolder: null,
				searchBar: null,

				wildSearch: null,
				wildSearchInput: null,
				wildSearchButton: null,
				extender: null,

				detailedSearch: null,
				detailedSearchPrimary: null,
				detailedSearchSecondary: null,

				searchBarButton: null,
				minimizer: null,

				widthContainer: null
			},

			_searchInputCounter: 0, // length of all inputs inside of a SearchBar
			_searchBarFormAction: "", // merged action of the SearchBar <form>

			_forcedDetailedSearch: false, // is there a wild search on this page?
			_isExtended: false, // is the detailed search form about to be expanded?
			_isExtendedToEnd: false, // is the detailed serach form expanded?
			_allowHardRecalc: true, // is it allowed to update all dimension properties of the SearchBar?

			_detailedSearchBarHeight: 0, // height of the detailed search form in px

			_mainDetailInputNode: null, // main input of the detail search

			_secondaryFieldsHighlightBeacon: null, // timer reference for the opacity animation delay of the secondary search fields

			_getStoredSearchBarStatus: function () {
				var hash = epages.localStorage.getItem(this._STORAGE_ID) || {};
				return hash[this.searchBarId] || null;
			},
			_setStoredSearchBarStatus: function (keyword /* String */ ) {
				var hash = epages.localStorage.getItem(this._STORAGE_ID) || {};
				hash[this.searchBarId] = keyword;

				epages.localStorage.setItem(this._STORAGE_ID, hash);
			},

			createSearchBar: function (searchBarId /* String */ , extendAtStartup /* Boolean */ , action /* Object */ , generalTranslations /* Object */ , fields /* Object */ ) {
				// summary:
				//		Creates a new SearchBar instance
				// description:
				//		Calling this method will cause an injection of a new SearchBar node in the page at the point where the script is declared.
				// searchBarId:
				//		A unique ID for the SearchBar.
				// extendAtStartup:
				//		States whether the detailed search or the wild search form is visible on startup.
				// action:
				//		ViewAction and ObjectID for the SearchBar form.
				// generalTranslations:
				//		Collection of page specific translation string for the SearchBar.
				// fields:
				//		Collection of input fields.
				// example:
				//	// Have a look at "MBO*.Toolbar.html"

				// no need to proceed if there is no id given
				if (!searchBarId) {
					return;
				}

				this.searchBarId = searchBarId;

				this.unity = fields.unity ? fields.unity : false;

				if (!fields.primary.length) {
					// no primary fields > no detailed search
					this._forcedDetailedSearch = extendAtStartup = this._isExtendedToEnd = false;
				}

				this._isExtended = this._forcedDetailedSearch = extendAtStartup;

				// merge the form action
				this._searchBarFormAction = "?ViewAction=" + action.viewAction + "&ObjectID=" + action.objectId;

				// inject the container nodes
				var posElem = !!$('RightSidebar') === false ? document.querySelector('#SearchBarContainer') : $('RightSidebar'),
					container = dojo.create('div', {
						'class': 'SearchBarRoot'
					}, posElem, 'before');

				var searchBarNode = dojo.create(
					'div', {
						'id': 'SearchBar',
						'class': 'SearchBar HideElementSoft'
					},
					container,
					'last');

				this.searchBarContainer = searchBarNode;

				// convert the object to a html collection
        var formString = "<form action='" + this._searchBarFormAction + "' method='post' id='WildSearch' class='WildSearch'>"
        if(!this.unity) formString += "<div><div id='Extender' class='" + (fields.primary.length ? "" : "HideElementSoft ") + "fa fa-caret-up fa-lg Extender EnableHover' title='" + generalTranslations.extendButtonTitle + "'></div>";
        // "<label unselectable='unselectable' for='WildSearchInput'>" + generalTranslations.wildSearchLabel+ "</label>";

        		if (generalTranslations.wildSearchString) {
					generalTranslations.wildSearchString = htmlEscape(generalTranslations.wildSearchString);
				}
				if (generalTranslations.wildSearchLabel == undefined) {
					generalTranslations.wildSearchLabel = '';
				}
				if (generalTranslations.wildSearchCustomInput) {
					var inp = generalTranslations.wildSearchCustomInput;
					formString += "<input placeholder='" + generalTranslations.wildSearchLabel + "' value='" + (generalTranslations.wildSearchString || "") + "' name='WildSearchString' class='ep-ui-smartsearch ep-js' data-js='.uiInput()'' />";
				} else {
          if(this.unity) {
            formString += "<input placeholder='" + generalTranslations.wildSearchLabel + "' value='" + (generalTranslations.wildSearchString || "") + "' type='text' name='WildSearchString' id='WildSearchInput' class='WildSearchInput'/>";
          } else {
            formString += "<input placeholder='" + generalTranslations.wildSearchLabel + "' value='" + (generalTranslations.wildSearchString || "") + "' " + this._ELEMENT_DOJOTYPE + " type='text' name='WildSearchString' id='WildSearchInput' class='WildSearchInput'/>";
          }
				}

        if (this.unity) {
          formString += "<button id='WildSearchButton' class='fa fa-search fa-lg SearchBarMiniButton CursorPointer' title='" + generalTranslations.searchButtonTitle + "'></button>";
        } else {
          formString += "<span id='WildSearchButton' class='fa fa-search fa-lg SearchBarMiniButton CursorPointer' title='" + generalTranslations.searchButtonTitle + "'></span>";
        }

        formString += "<input type='submit' class='HideElementSoft'/>";

				this.searchBarHTMLArray.push(formString);
				for (var i = 0, iLength = fields.hidden.length; i < iLength; i++) {
					this.searchBarHTMLArray.push("<input type='hidden' name='" + fields.hidden[i].name + "' value='" + fields.hidden[i].value + "'/>");
				}

        if (this.unity) {
          this.searchBarHTMLArray.push(
            "<button id='Extender'  onclick='return false;' class='" + (fields.primary.length ? "" : "HideElementSoft ") + "Button Extender' title='" + generalTranslations.extendButtonTitle + "'>" + generalTranslations.extendButtonTitle + " <i class='fa fa-caret-down fa-lg'></i></button>" +
            "<button id='Minimizer'  onclick='return false;' class='" + (fields.primary.length ? "" : "HideElementSoft ") + "Button Extender HideElementSoft' title='" + generalTranslations.extendButtonTitle + "'>" + generalTranslations.extendButtonTitle + " <i class='fa fa-caret-up fa-lg'></i></button>" +
          	"</form>");
        } else {
          this.searchBarHTMLArray.push("</div></form>");
        }

				this.searchBarHTMLArray.push("<form action='" + this._searchBarFormAction + "' method='post' id='DetailedSearch' class='DetailedSearch" + " HideElementSoft" + "'><div>");

				for (var i = 0, iLength = fields.hidden.length; i < iLength; i++) {
					this.searchBarHTMLArray.push("<input type='hidden' name='" + fields.hidden[i].name + "' value='" + fields.hidden[i].value + "'/>");
				}

				this.searchBarHTMLArray.push("<div id='DetailedSearchPrimary' class='Primary'>");
				this._buildFormElements(fields.primary);

				this.searchBarHTMLArray.push("</div><div id='DetailedSearchSecondary' class='Secondary'>");

				if (fields.secondary && fields.secondary.length) {
					this._buildFormElements(fields.secondary);
				}

			if (this.unity) {
				this.searchBarHTMLArray.push("</div><div id='DetailedSearchTertiary' class='Tertiary'>");

				if (fields.tertiary && fields.tertiary.length) {
					this._buildFormElements(fields.tertiary);
				}
			}

				this.searchBarHTMLArray.push("</div>" + ((this.unity) ? "" : ("<div id='Minimizer' class='Minimizer EnableHover' title='" + generalTranslations.minimizeButtonTitle + "'></div>")));
				this.searchBarHTMLArray.push("<div class='SearchBarButtonContainer'><div><input dojoType='epages.widget.Button' type='submit' id='SearchBarButton' class='SearchBarButton Button' value='" + generalTranslations.searchButtonTitle + "' iconSrc='dialog_ico_s_loupe'/></div><div class='RoundCornerPatch'></div></div></form>");

				this._initSearchBar();
			},

			_getFieldCount: function (fieldArray) {
				var fieldArrayFiltered = [];
				var isGroupOpened = false;
				for (var i = 0, iLength = fieldArray.length; i < iLength; i++) {
					if (isGroupOpened) {
						if (fieldArray[i].type == "endgroup") {
							isGroupOpened = false;
						}
					} else {
						if (fieldArray[i].type == "startgroup") {
							isGroupOpened = true;
						}
						fieldArrayFiltered.push(fieldArray[i]);
						fieldArrayFiltered.push(fieldArray[i]);
					}
				}
				return fieldArrayFiltered;
			},

			_buildFormElements: function (elementArray) {
				// traverse the element array and build up the specific html code for every entry
				for (var i = 0, iLength = elementArray.length; i < iLength; i++) {
					if (elementArray[i].defaultValue) {
						elementArray[i].defaultValue = htmlEscape(elementArray[i].defaultValue);
					}

					switch (elementArray[i].type) {
					case "select":
						this._formElements.getSelect(elementArray[i], this._getInputId(), this);
						break;
					case "checkbox":
						this._formElements.getCheckbox(elementArray[i], this._getInputId(), this);
						break;
					case "date":
						this._formElements.getDateInput(elementArray[i], this._getInputId(), this);
						break;
					case "datetime":
						this._formElements.getDateTimeInput(elementArray[i], this._getInputId(), this);
						break;
					case "multioptions":
						this._formElements.getMultiOptionsInput(elementArray[i], this._getInputId(), this);
						break;
					case "startgroup":
						this._formElements.getGroupStart(elementArray[i], this);
						break;
					case "endgroup":
						this._formElements.getGroupEnd(this);
						break;
					case "custom":
						this._formElements.getCustom(elementArray[i], this);
						break;
					default:
						this._formElements.getInput(elementArray[i], this._getInputId(), this);
						break;
					}
				}
			},

			_formElements: {
				// collection of all available input types inside of a SearchBar (called via "_buildFormElements")
				_getLabel: function (label, id, adjacentText) {
					return "<label unselectable='unselectable' for='" + id + "'>" + label + this._getAdjacentText(adjacentText) + "</label>";
				},
				_getAdjacentText: function (text) {
					return (text ? " " + text + "" : "");
				},
				getSelect: function (arrayEntry, id, scope) {
					scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup SelectGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText) +
						"<select " + scope._ELEMENT_DOJOTYPE + " id='" + id + "' name='" + arrayEntry.name + "'>");
					for (var i = 0, iLength = arrayEntry.options.length; i < iLength; i++) {
						scope.searchBarHTMLArray.push("<option value='" + arrayEntry.options[i].value + "' " + (arrayEntry.options[i].selected ? "selected='selected'" : "") + ">" + arrayEntry.options[i].label + "</option>");
					}
					scope.searchBarHTMLArray.push("</select></span>");
				},
				getCheckbox: function (arrayEntry, id, scope) {
					scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup CheckboxGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText) +
						"<input value='" + arrayEntry.defaultValue + "' id='" + id + "' " + scope._ELEMENT_DOJOTYPE + " type='text' class='Checkbox' name='" + arrayEntry.name + "' " + (arrayEntry.checked ? "checked='checked'" : "") + "/>" +
						"</span>");
				},
				getDateInput: function (arrayEntry, id, scope) {
					scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup DateGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText) +
						"<input onchange='epages.cartridges.de_epages.presentation.SearchBar._checkErrorState()' empty='true' selector='date' class='SearchDate ep-date-input' id='" + id + "' type='text' name='" + arrayEntry.name + "' value='" + (arrayEntry.defaultValue || "") + "'/></span>");
				},
				getDateTimeInput: function (arrayEntry, id, scope) {
					scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup DateTimeGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText) +
						"<input onchange='epages.cartridges.de_epages.presentation.SearchBar._checkErrorState()' selector='datetime' class='SearchDate ep-date-time-input' id='" + id + "' type='text' empty='true' name='" + arrayEntry.name + "' value='" + (arrayEntry.defaultValue || "") + "'/></span>");
				},
				getMultiOptionsInput: function (arrayEntry, id, scope) {
					scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup SelectGroup MultiOptionsGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText));

					var optionCollection = [];
					var preSelectedValueCollection = [];
					for (var i = 0, iLength = arrayEntry.options.length; i < iLength; i++) {
						optionCollection.push("<option ep_name='" + arrayEntry.options[i].name + "'>" + arrayEntry.options[i].label + "</option>");
						if (arrayEntry.options[i].defaultValue) {
							preSelectedValueCollection.push(scope._getMultipleOptionsPreSelected(arrayEntry.options[i].name, arrayEntry.options[i].label, arrayEntry.translations[3], arrayEntry.translations[0], arrayEntry.translations[1], (arrayEntry.options[i].defaultValue == 2 ? true : false)));
						}
					}

					scope.searchBarHTMLArray.push("<span class='MultiOptionsGroupSelectContainer'><span class='SelectedEntries'>" + preSelectedValueCollection.join("") + "</span>" +
						"<select onchange='epages.cartridges.de_epages.presentation.SearchBar._addMultipleOptionsOption(this)' " + scope._ELEMENT_DOJOTYPE + " id='" + id + "' ep_nottranslation='" + arrayEntry.translations[3] + "' ep_removetranslation='" + arrayEntry.translations[4] + "'>");

					scope.searchBarHTMLArray = scope.searchBarHTMLArray.concat(optionCollection);

					var insertHiddenStyle = (scope.searchBarId.match(/SearchOrders/)) ? " style=\"display:none;\"" : "";
					scope.searchBarHTMLArray.push("</select><span class='DetailSelector LeftPadding'" + insertHiddenStyle + ">" +
						"<input id='radio_" + id + "_true' name='radio_" + id + "_true' type='text' disabled='disabled' class='Disabled Checked Radio' checked='checked'/><label class='RightPadding' for='radio_" + id + "_true'>" + arrayEntry.translations[0] + "</label>" +
						"<input id='radio_" + id + "_false' name='radio_" + id + "_false' type='text' disabled='disabled' class='Disabled Radio' /><label for='radio_" + id + "_false'>" + arrayEntry.translations[1] + "</label>" +
						"</span></span></span>");
				},
				getInput: function (arrayEntry, id, scope) {
					scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup InputGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText) +
						"<input " + scope._ELEMENT_DOJOTYPE + " id='" + id + "' type='text' name='" + arrayEntry.name + "' value='" + (arrayEntry.defaultValue || "") + "'/></span>");
				},
				getGroupStart: function (arrayEntry, scope) {
					scope.searchBarHTMLArray.push("<span class='EnableHover Group " + (arrayEntry.cssClass || "") + "'>");
				},
				getGroupEnd: function (scope) {
					scope.searchBarHTMLArray.push("</span>");
				},
				getCustom: function (arrayEntry, scope) {
					scope.searchBarHTMLArray.push(arrayEntry.html);
				}
			},

			_getMultipleOptionsPreSelected: function (inputName, selectValue, removeTranslation, yesTranslation, noTranslation, selectReverse) {
				if ($(inputName + "_true")) {
					return "";
				}
				return "<span class='SelectedEntry'>" +
					"<span class='SelectedEntryLabel'>" + selectValue + "</span>" +
					"<input id='" + inputName + "_true' value='1' name='" + inputName + "' type='text' class='Radio' dojoType='epages.widget.FormElement' " + (selectReverse ? "" : "checked='checked'") + "/><label class='RightPadding' for='" + inputName + "_true'>" + yesTranslation + "</label>" +
					"<input id='" + inputName + "_false' value='2' name='" + inputName + "' type='text' class='Radio' dojoType='epages.widget.FormElement' " + (selectReverse ? "checked='checked'" : "") + "/><label for='" + inputName + "_false'>" + noTranslation + "</label>" +
					"<i title='" + removeTranslation + "' class='RemoveButton Sprite ico_s_remove' onclick='epages.cartridges.de_epages.presentation.SearchBar._removeMultipleOptionsSelector(this)'></i>" +
					"</span>";
			},

			_addMultipleOptionsOption: function (selectNode) {

				if (selectNode.selectedIndex === 0) {
					return;
				}

				var selectContainer = selectNode.parentNode.parentNode;
				selectContainer = epages.Browser.engine == "MSIE" ? selectContainer.parentNode : selectContainer;

				var entriesContainer = dojo.query(".SelectedEntries", selectContainer)[0];
				var selectLabels = dojo.query("label", selectContainer);
				var inputName = selectNode.options[selectNode.selectedIndex].getAttribute("ep_name");

				var removeTranslation = selectNode.getAttribute("ep_removetranslation");
				var selectValue = selectNode.value || selectNode.options[selectNode.selectedIndex].innerHTML;

				var labelsLength = selectLabels.length;

				var newSelectedEntryHTML = this._getMultipleOptionsPreSelected(inputName, selectValue, removeTranslation, selectLabels[labelsLength - 2].innerHTML, selectLabels[labelsLength - 1].innerHTML, false);
				var tempContainer = document.createElement("div");

				if (newSelectedEntryHTML.length > 2) {
					tempContainer.innerHTML = newSelectedEntryHTML;
					entriesContainer.appendChild(tempContainer.firstChild);
					dojo.parser.parse(entriesContainer.lastChild);
				}

				selectNode.selectedIndex = 0;
				this._hardRecalcSearchBarHeight();
			},

			_removeMultipleOptionsSelector: function (iconNode) {
				var entry = iconNode.parentNode;
				var entriesContainer = entry.parentNode;

				dojo.query("input.Radio", entry).forEach(function (radioWidget) {
					$$(radioWidget.id).destroy();
				});

				entriesContainer.removeChild(entry);

				this._hardRecalcSearchBarHeight();
			},

			_getInputId: function () {
				// returns the ID for a new SearchBar element
				this._searchInputCounter++;
				return this._SEARCH_INPUT_PREFIX + this._searchInputCounter;
			},

			_injectSearchBarCode: function () {
				// merge the html snipplets
				//this.searchBarContainer.innerHTML = this.searchBarHTMLArray.join("");

				// parse the merged html
				//dojo.parser.parse(this.searchBarContainer);

				// workaround parseOnLoad <> dojo.parser conflict
				var temp = document.createElement('div');
				var self = this;
				temp.innerHTML = self.searchBarHTMLArray.join("");

				dojo.parser.parse(temp);
				dojo.query('*[dojoType]', temp).forEach(function (node, i) {
					dojo.removeAttr(node, 'dojoType');
				});
				self.searchBarContainer.appendChild(temp);


				// link the node references
				self.searchBarNodes.searchBarPlaceHolder = $("SearchBarPlaceHolder");
				self.searchBarNodes.searchBar = $("SearchBar");

				self.searchBarNodes.wildSearch = $("WildSearch");
				self.searchBarNodes.wildSearchInput = $("WildSearchInput");
				self.searchBarNodes.wildSearchString = dojo.query('[name=WildSearchString]')[0];
				self.searchBarNodes.wildSearchButton = $("WildSearchButton");
				self.searchBarNodes.extender = $("Extender");

				self.searchBarNodes.detailedSearch = $("DetailedSearch");
				self.searchBarNodes.detailedSearchPrimary = $("DetailedSearchPrimary");
				self.searchBarNodes.detailedSearchSecondary = $("DetailedSearchSecondary");

				self.searchBarNodes.searchBarButton = $("SearchBarButton");
				self.searchBarNodes.minimizer = $("Minimizer");

				self.searchBarNodes.widthContainer = $("DetailedSearchWidthContainer") || document.createElement("div");

				// is there an equivalent wild search input element inside of the detail search mask?
				self._mainDetailInputNode = dojo.query(".MainDetailInputNode input", self.searchBarNodes.detailedSearchPrimary)[0];

				require([
				    "jquery",

				    "ep/ui/datepicker",
				    "$ready!"
				], function ($) {
				    var searchbar = $('#SearchBar');
				    var dateInputs = searchbar.find('.ep-date-input');
				    var dateTimeInputs = searchbar.find('.ep-date-time-input');

						if (dateInputs.length) {
							dateInputs.uiDatepicker({
								'type': 'date',
								'format': 'd',
								'time': false,
								'bubble': true,
								'unity': self.unity
							});
						}

						if (dateTimeInputs.length) {
							dateTimeInputs.uiDatepicker({
								'type': 'date',
								'format': 'l',
								'time': true,
								'bubble': true,
								'unity': self.unity
							});
						}

				});
			},

			_appendSearchBarEvents: function () {
				dojo.connect(this.searchBarNodes.wildSearchButton, "click", this, "_searchBarMiniButtonClick");
				dojo.connect(this.searchBarNodes.extender, "click", this, "_extenderClick");

				dojo.connect(this.searchBarNodes.searchBarButton, "click", this, "_searchBarButtonClick");
				dojo.connect(this.searchBarNodes.searchBar, "keyup", this, "_checkErrorState");
				dojo.connect(this.searchBarNodes.minimizer, "click", this, "_minimizerClick");
			},

			showSearchBar: function (soft /* Boolean */ ) {
				var duration = this.unity ? 0 : 350;  // animation duration: 0ms for unity, default (350ms) for core

				this.searchBarNodes.detailedSearch.style.height = '0';
				dojo.removeClass(this.searchBarNodes.detailedSearch, 'HideElementSoft');

				if (!this.unity) {
					dojo.addClass(this.searchBarNodes.wildSearch, 'HideElementSoft');
				} else {

					if (this.searchBarNodes.wildSearchInput === null) {
						dojo.addClass(this.searchBarNodes.wildSearchString, 'HideElementSoft');
					} else {
						dojo.addClass(this.searchBarNodes.wildSearchInput, 'HideElementSoft');
					}

					dojo.addClass(this.searchBarNodes.extender, 'HideElementSoft');
					dojo.addClass(this.searchBarNodes.wildSearchButton, 'HideElementSoft');
					dojo.removeClass(this.searchBarNodes.minimizer, 'HideElementSoft');

				}

				dojo.fx.wipeIn({
					node: this.searchBarNodes.detailedSearch,
					duration: duration
				}).play();
				this._setStoredSearchBarStatus(this._STORAGE_EXTENDED_KEYWORD);
				this._isExtended = true;
				if (this._mainDetailInputNode) {
					this._mainDetailInputNode.focus();
					this._mainDetailInputNode.select();
				}
			},

			hideSearchBar: function ( /* Boolean */ soft) {
				var duration = this.unity ? 0 : 350;  // animation duration: 0ms for unity, default (350ms) for core

				dojo.fx.wipeOut({
					node: this.searchBarNodes.detailedSearch,
					duration: duration,
					onEnd: dojo.hitch(this, function () {

						if (!this.unity) {
							dojo.removeClass(this.searchBarNodes.wildSearch, 'HideElementSoft');
						} else {

							if (this.searchBarNodes.wildSearchInput === null) {
								dojo.removeClass(this.searchBarNodes.wildSearchString, 'HideElementSoft');
							} else {
								dojo.removeClass(this.searchBarNodes.wildSearchInput, 'HideElementSoft');
							}

							dojo.removeClass(this.searchBarNodes.extender, 'HideElementSoft');
							dojo.removeClass(this.searchBarNodes.wildSearchButton, 'HideElementSoft');
							dojo.addClass(this.searchBarNodes.minimizer, 'HideElementSoft');
						}
					})
				}).play();
				this._setStoredSearchBarStatus(this._STORAGE_MINIMIZED_KEYWORD);
				this._isExtended = false;
			},

			_minimizerClick: function (evt) {
				this.hideSearchBar(true);
			},

			_extenderClick: function (evt) {
				this.showSearchBar(true);
			},

			_searchBarButtonClick: function (evt) {
				this.submitForm(this.searchBarNodes.detailedSearch);
			},

			_checkErrorState: function () {
				var searchBarButtonWidget = $$(this.searchBarNodes.searchBarButton.id);
				if (dojo.query("input.DialogError", this.searchBarNodes.detailedSearch).length) {
					searchBarButtonWidget.disable();
				} else {
					searchBarButtonWidget.enable();
					dojo.removeClass(this.searchBarNodes.searchBarButton.parentNode, "Active");
				}
			},

			_searchBarMiniButtonClick: function (evt) {
				this.submitForm(this.searchBarNodes.wildSearch);
			},

			submitForm: function (formNode) {
				if (!dojo.query("input.DialogError", formNode).length) {
					formNode.submit();
				}
			},

			_hardRecalcSearchBarHeight: function () {
				this._detailedSearchBarHeight = this.searchBarNodes.detailedSearch.offsetHeight - 10;
				setTimeout(dojo.hitch(this, function () {
					this._detailedSearchBarHeight = this.searchBarNodes.detailedSearch.offsetHeight - 10;
					if (this._isExtended) {
						if (!(epages.Browser.engine == "MSIE" && (epages.Browser.version == "7" || epages.Browser.version == "8"))) {
							//this.searchBarNodes.searchBarPlaceHolder.style.height = "auto";
						}
						//this.searchBarNodes.searchBarPlaceHolder.style.height = this._detailedSearchBarHeight + "px";
					}
				}), 1);
			},

			_hardRecalcDimensions: function () {
				if (!this._allowHardRecalc) {
					return;
				}
				var limitNode = this.searchBarNodes.detailedSearchSecondary.parentNode;
				//this.searchBarNodes.searchBar.style.visibility = "hidden";
				//limitNode.style.width = "auto";
				limitNode.style.filter = "alpha()";
				this.searchBarNodes.widthContainer.style.display = "inline";
				setTimeout(dojo.hitch(this, function () {
					var hiddenClassSet = dojo.hasClass(this.searchBarNodes.detailedSearch, "HideElementSoft");
					dojo.removeClass(this.searchBarNodes.detailedSearch, "HideElementSoft");

					//limitNode.style.width = (epages.Browser.engine == "MSIE" ? this.searchBarNodes.detailedSearchSecondary : this.searchBarNodes.widthContainer).offsetWidth + "px";
					this.searchBarNodes.widthContainer.style.display = "block";
					if (hiddenClassSet) {
						dojo.addClass(this.searchBarNodes.detailedSearch, "HideElementSoft");
					}
					limitNode.style.filter = "none";
					this.searchBarNodes.searchBar.style.visibility = "visible";
				}), 1);
				this._hardRecalcSearchBarHeight();
			},

			_initSearchBar: function () {
				this._injectSearchBarCode();
				this._appendSearchBarEvents();

				if (!this._forcedDetailedSearch) {
					var searchBarStatus = this._getStoredSearchBarStatus();
					if (searchBarStatus == this._STORAGE_EXTENDED_KEYWORD) {
						this.showSearchBar(false);
					} else {
						this.hideSearchBar(false);
					}
				}
				this.searchBarNodes.searchBar.style.visibility = "hidden";
				dojo.removeClass(this.searchBarContainer, "HideElementSoft");
				if ($$('RightSidebar')) {
					this._checkWildSearchBarPadding({
						width: $$('RightSidebar').isVisible
					});
				}
				this._hardRecalcDimensions();

				setTimeout(dojo.hitch(this, function () {

					this._hardRecalcDimensions();
					if (!this._isExtended) {
						this._allowHardRecalc = false;
					}

					dojo.connect(window, "resize", this, "_hardRecalcDimensions");

					// only IE fires the resize event when the sidebar status changed
					if (epages.Browser.engine != "MSIE") {
						var sideBarController = $("Sidebarcontroller");
						if (sideBarController) {
							dojo.addOnLoad(dojo.hitch(this, function () {

								dojo.subscribe(dojo.query("[id*=Sidebar]", sideBarController)[0].id + "/afterShowSidebar", dojo.hitch(this, function () {
									setTimeout(dojo.hitch(this, function () {
										this._hardRecalcDimensions();
									}), 1);
								}));

							}));
						}
					}

					// sometimes it is necessary to update the dimension styles after all surrounding elements are rendered
					setTimeout(dojo.hitch(this, function () {
						var temp_allowHardRecalc = this._allowHardRecalc;
						this._allowHardRecalc = true;
						this._hardRecalcDimensions();
						this._allowHardRecalc = temp_allowHardRecalc;

						this._checkErrorState();
						if (this._isExtended) {
							this.showSearchBar();
						}
						dojo.publish("SearchBar/ready", [this.searchBarNodes.searchBar]);
					}), 1);

				}), 10);

				dojo.subscribe('RightSidebar/afterShowSidebar', this, '_checkWildSearchBarPadding');
				dojo.subscribe('RightSidebar/afterHideSidebar', this, '_checkWildSearchBarPadding');

			},

			_checkWildSearchBarPadding: function (options) {
				if (options.width) {
					this.searchBarNodes.wildSearch.style.marginRight = '230px';
				} else {
					this.searchBarNodes.wildSearch.style.marginRight = '10px';
				}

			}

		};

	})();

}
